<template>
    <v-container fluid>

        <v-card :elevation="6" max-width="1200" class="ma-auto">
            <div class="text-h4 text-lg-h3 pa-7">
                {{worker.light.name }}
            </div>
        </v-card>
    </v-container>
</template>

<style lang='scss' scoped>
</style>

<script lang='ts'>
    import {Component} from "vue-property-decorator";
    import {Mixins} from "vue-mixin-decorator";
    import {Initializable} from "../../mixins/Initializable";
    import {WorkerResponse} from "../../../../classLibrary/core/workerResponse";
    import {coreApi} from "../../init";
    import {FloorPlanFlyWeightResponse} from "../../../../classLibrary/core/floorPlanFlyWeightResponse";
    import {RawLocation} from "vue-router";
    import {SubContractorResponse} from "../../../../classLibrary/core/subContractorResponse";
    import {WorkerLightResponse} from "../../../../classLibrary/core/workerLightResponse";
    import {SubContractorLightResponse} from "../../../../classLibrary/core/subContractorLightResponse";
    import {TagLightResponse} from "../../../../classLibrary/core/tagLightResponse";

    interface TemplateMixin extends Initializable {

    }

    @Component({})
    export default class WorkerView extends Mixins<TemplateMixin>(Initializable) {


        //Parameters
        subconId: string = '';
        workerId: string = '';
        floorId?: string;


        worker: WorkerResponse = new WorkerResponse(new WorkerLightResponse('Name', '0', [], '', {}),
            new SubContractorLightResponse('', '0', '', '', {}),
            new TagLightResponse('', []));
        sub: SubContractorResponse = new SubContractorResponse(new SubContractorLightResponse('', '0', '', '', {}), []);
        floors: FloorPlanFlyWeightResponse[] = [];
        currentFloor?: FloorPlanFlyWeightResponse;

        async init() {
            this.loadQuery();
            await this.verifyQuery();
        }

        updateQuery() {
            const route: RawLocation = {
                name: 'analytics',
                params: {
                    subconId: this.subconId,
                    workerId: this.workerId
                },
                query: {}
            }

            if (this.floorId != null) route.query!['floor'] = this.floorId
        }

        loadQuery() {
            const query = this.$route.query;
            this.subconId = this.$route.params.subconId;
            this.workerId = this.$route.params.workerId;
            this.floorId = query.floor as any;
        }

        async verifyQuery() {
            const subResult = await coreApi.Get<SubContractorResponse>(`SubContractor/${this.subconId}`);
            if (!subResult.success) await this.$router.push("/notfound?subcontractor-not-found");
            this.sub = subResult.Ok!;

            const workerResult = await coreApi.Get<WorkerResponse>(`Worker/${this.subconId}/${this.workerId}`);
            if (!workerResult.success) await this.$router.push("/notfound?worker-not-found");
            this.worker = workerResult.Ok!;

            const floorsResult = await coreApi.Get<FloorPlanFlyWeightResponse[]>('Floor');
            if (!floorsResult.success) await this.$router.push("/notfound?floors-api-fail");
            this.floors = floorsResult.Ok!;

            if (this.floorId != null) {
                const cFloor = this.floors.Find(e => e.id == this.floorId);
                if (cFloor == null) await this.$router.push("/notfound?floor-not-found");
                this.currentFloor = cFloor!;
            }

        }

        async mountInit() {

        }
    }
</script>
